#ifndef utils_dot_H_header
#define utils_dot_H_header

// helper for debugging sessions ;-)
#define MARK  cout << "now in " << __FILE__ << ", " << __FUNCTION__ << ": line " <<  __LINE__ << endl;


// define templates for MIN and MAX:
template<typename T> inline T MIN(const T a, const T b) { return (a<=b) ? a : b; }
template<typename T> inline T MAX(const T a, const T b) { return (a>=b) ? a : b; }


class ForbidAssignment
{
 public:
  inline ForbidAssignment() { }
 private:
  ForbidAssignment(const ForbidAssignment&); // declaration intentianally without implementation!
  inline const ForbidAssignment& operator= (const ForbidAssignment&) const { return *this; }
  // only a dummy declaration/definition to forbid any implicit inherited use
  // of the assignment operator
};


#endif
